// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "TestVisio.h"

//XD++ Library add lines.
#include "TestVisioDoc.h"
#include "TestVisioView.h"
#include "ChildFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
			//XD++ Library add lines.
			ON_WM_CREATE()
			ON_COMMAND(ID_VIEW_RULER, OnViewRuler)
			ON_UPDATE_COMMAND_UI(ID_VIEW_RULER, OnUpdateViewRuler)
			//XD++ Library add lines.
			ON_COMMAND(ID_FO_ADD_NEWPAGE, OnFoAddNewpage)
			ON_COMMAND(ID_FO_REMOVE_PAGE, OnFoRemovePage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREAFOAPPWIZARDRUCT cs

	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;
//XD++ Library add lines.
	cs.style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU
		| FWS_ADDTOTITLE | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers
//XD++ add lines.
int CChildFrame::OnCreate(LPCREATESTRUCT LPCREATESTRUCT) 
{
	if (CMDIChildWnd::OnCreate(LPCREATESTRUCT) == -1)
		return -1;
	if (!CreateRulerBar())
		return -1;
	// TODO: Add your specialized creation code here
	
	return 0;
}
#define ID_VIEW_RULERH 30022
#define ID_VIEW_RULERV 30023
BOOL CChildFrame::CreateRulerBar()
{

	if (!m_wndRulerBarH.Create(this, 
		CBRS_TOP|CBRS_HIDE_INPLACE, ID_VIEW_RULERH))
	{
		TRACE0("Failed to create ruler\n");
		return FALSE;      // fail to create
	}

	if (!m_wndRulerBarV.Create(this, 
		CBRS_LEFT|CBRS_HIDE_INPLACE, ID_VIEW_RULERV))
	{
		TRACE0("Failed to create ruler\n");
		return FALSE;      // fail to create
	}
	
	return TRUE;	
	 
} 

void CChildFrame::OnViewRuler() 
{
	// TODO: Add your command handler code here
	if(m_wndRulerBarH.IsWindowVisible()||m_wndRulerBarV.IsWindowVisible())
	{
		m_wndRulerBarH.ShowWindow(SW_HIDE);
		m_wndRulerBarV.ShowWindow(SW_HIDE);
	}
	else
	{
		m_wndRulerBarH.ShowWindow(SW_SHOW);
		m_wndRulerBarV.ShowWindow(SW_SHOW);
	}
	RecalcLayout(TRUE);
}

void CChildFrame::OnUpdateViewRuler(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_wndRulerBarH.IsWindowVisible()||m_wndRulerBarV.IsWindowVisible());
}

//XD++ Library add lines.
void CChildFrame::ActivateFrame(int nCmdShow)
{
	nCmdShow = SW_SHOWMAXIMIZED;
	// TODO: Modify this function to change how the frame is activated.
	CMDIChildWnd::ActivateFrame(nCmdShow);
	CTestVisioDoc* pDoc = (CTestVisioDoc*) GetActiveDocument();

	if(pDoc->bNewDocument)
	{
		pDoc->bNewDocument = FALSE;
	}
	else if(pDoc->bOpenDocument)
	{
		pDoc->bOpenDocument = FALSE;
		for(int x = 1;x < pDoc->m_pModelManager->GetTabCount(); x++)
		{
			CFOTabPageModel *pModel = (CFOTabPageModel *)pDoc->m_pModelManager->m_arTabs[x];
			if(pModel != NULL)
			{
				m_wndTab.InsertPage(pModel,NULL);
			}
		}
		if(pDoc->m_pModelManager->GetTabCount() > 1)
		{
			if(m_wndTab.RemoveTab(0,FALSE))
			{
				pDoc->m_pModelManager->DeleteTab(0);
			}
		}
	}

}

BOOL CChildFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	pContext->m_pNewViewClass = RUNTIME_CLASS(CTestVisioView);

	// creates the tab window
	CTestVisioDoc* pDoc = (CTestVisioDoc*) pContext->m_pCurrentDoc;
	CFOTabPageModel *pModel = (CFOTabPageModel *)pDoc->m_pModelManager->InsertTab();
	VERIFY(m_wndTab.Create(this,pContext));
	// next sheets
	m_wndTab.InsertPage(pModel,pContext);

	return TRUE;
}

void CChildFrame::OnFoAddNewpage() 
{
	// TODO: Add your command handler code here
	CTestVisioDoc* pDoc = (CTestVisioDoc*)GetActiveDocument();
	CFOTabPageModel *pModel = (CFOTabPageModel *)pDoc->m_pModelManager->InsertTab();
	m_wndTab.InsertPage(pModel,NULL);
}

void CChildFrame::OnFoRemovePage() 
{
	// TODO: Add your command handler code here
	CTestVisioDoc* pDoc = (CTestVisioDoc*) GetActiveDocument();
	int nCurrentTab = m_wndTab.GetTabControl()->m_nSelect;
	if(m_wndTab.RemoveTab(nCurrentTab))
	{
		pDoc->m_pModelManager->DeleteTab(nCurrentTab);
	}
}
