// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TestVisio.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_DRAWBAR, OnViewDrawbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DRAWBAR, OnUpdateViewDrawbar)
	ON_COMMAND(ID_VIEW_FORMATBAR, OnViewFormatbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FORMATBAR, OnUpdateViewFormatbar)
	ON_COMMAND(ID_VIEW_TOOLBOX, OnViewToolbox)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBOX, OnUpdateViewToolbox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_FO_INDEX_WIDTH,
	ID_FO_INDEX_HEIGHT,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT LPCREATESTRUCT)
{
	if (CMDIFrameWnd::OnCreate(LPCREATESTRUCT) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	
	// Create draw toolbar.
	if (!m_wndDrawToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndDrawToolBar.LoadToolBar(IDR_FO_DRAWCOMPBAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	
	// Create format toolbar.
	if (!m_wndFormatToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndFormatToolBar.LoadToolBar(IDR_FO_FORMAT))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// Create align toolbar.
	if (!m_wndAllignToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndAllignToolBar.LoadToolBar(IDR_FO_FORMAT_ALIGN))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndLinkToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndLinkToolBar.LoadToolBar(IDR_FO_LINK_TOOLBAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// Create toolbox
	if (!m_FileBar.Create(this,ID_VIEW_TOOLBOX,_T("Docking Window"),CSize(200, 150)))
    {
        TRACE0("Failed to create m_FileBar\n");
        return -1;      // fail to create
	}
	m_FileBar.SetBarStyle(m_FileBar.GetBarStyle() |
        CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable

	// looks a little bit better...
	m_wndToolBar.SetBorders(2,2,2,2);
	m_wndToolBar.SetWindowText(_T("Standard"));

	m_wndAllignToolBar.SetBorders(2,2,2,2);
	m_wndAllignToolBar.SetWindowText(_T("Align"));

	m_wndFormatToolBar.SetBorders(2,2,2,2);
	m_wndFormatToolBar.SetWindowText(_T("Format"));

	m_wndDrawToolBar.SetBorders(2,2,2,2);
	m_wndDrawToolBar.SetWindowText(_T("Draw"));

	m_wndLinkToolBar.SetBorders(2,2,2,2);
	m_wndLinkToolBar.SetWindowText(_T("Link"));

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndDrawToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndFormatToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndAllignToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndLinkToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_FileBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	DockControlBar(&m_wndDrawToolBar,AFX_IDW_DOCKBAR_RIGHT);
	DockControlBar(&m_wndAllignToolBar,AFX_IDW_DOCKBAR_BOTTOM);
	DockControlBar(&m_wndLinkToolBar,AFX_IDW_DOCKBAR_TOP);
	DockControlBarLeftOf(&m_wndFormatToolBar,&m_wndToolBar);
	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_FileBar, AFX_IDW_DOCKBAR_LEFT);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	//XD++ Library add lines.
	int DesktopWidth  = GetSystemMetrics(SM_CXSCREEN);
	int DesktopHeight = GetSystemMetrics(SM_CYSCREEN);

	// Just Make It Small So We Will Not Feel a "Blink"
	CRect MainWindow_Rect(0,0, DesktopWidth, DesktopHeight); // First Opening Screen

	cs.x = (DesktopWidth - MainWindow_Rect.right)/2;
	cs.y = (DesktopHeight - MainWindow_Rect.bottom)/2;

    cs.cx = MainWindow_Rect.right;
	cs.cy = MainWindow_Rect.bottom;
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREAFOAPPWIZARDRUCT cs
	//XD++ Library add lines.
	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		| WS_THICKFRAME | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_MAXIMIZE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


//XD++ Library add lines.
void CMainFrame::OnViewDrawbar() 
{
	// TODO: Add your command handler code here
	BOOL bVisible = m_wndDrawToolBar.IsWindowVisible();
	if(bVisible)
	{
		ShowControlBar(&m_wndDrawToolBar,FALSE,FALSE);
	}
	else
	{
		ShowControlBar(&m_wndDrawToolBar,TRUE,FALSE);
	}
}

void CMainFrame::OnUpdateViewDrawbar(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_wndDrawToolBar.IsWindowVisible());
}
//XD++ Library add lines.
void CMainFrame::OnViewFormatbar() 
{
	// TODO: Add your command handler code here
	BOOL bVisible = m_wndFormatToolBar.IsWindowVisible();
	if(bVisible)
	{
		ShowControlBar(&m_wndFormatToolBar,FALSE,FALSE);
	}
	else
	{
		ShowControlBar(&m_wndFormatToolBar,TRUE,FALSE);
	}
}

void CMainFrame::OnUpdateViewFormatbar(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_wndFormatToolBar.IsWindowVisible());
}
//XD++ Library add lines.
void CMainFrame::DockControlBarLeftOf(CToolBar* Bar,CToolBar* LeftOf)
{
	CRect rect;
	DWORD dw;
	UINT n;

	// get MFC to adjust the dimensions of all docked ToolBars
	// so that GetWindowRect will be accurate
	RecalcLayout();
	LeftOf->GetWindowRect(&rect);
	rect.OffsetRect(1,0);
	dw=LeftOf->GetBarStyle();
	n = 0;
	n = (dw&CBRS_ALIGN_TOP) ? AFX_IDW_DOCKBAR_TOP : n;
	n = (dw&CBRS_ALIGN_BOTTOM && n==0) ? AFX_IDW_DOCKBAR_BOTTOM : n;
	n = (dw&CBRS_ALIGN_LEFT && n==0) ? AFX_IDW_DOCKBAR_LEFT : n;
	n = (dw&CBRS_ALIGN_RIGHT && n==0) ? AFX_IDW_DOCKBAR_RIGHT : n;

	// When we take the default parameters on rect, DockControlBar will dock
	// each Toolbar on a seperate line.  By calculating a rectangle, we in effect
	// are simulating a Toolbar being dragged to that location and docked.
	DockControlBar(Bar,n,&rect);
}

//XD++ Library add lines.
void CMainFrame::OnViewToolbox() 
{
	// TODO: Add your command handler code here
	BOOL bVisible = m_FileBar.IsWindowVisible();
	if(bVisible)
	{
		ShowControlBar(&m_FileBar,FALSE,FALSE);
	}
	else
	{
		ShowControlBar(&m_FileBar,TRUE,FALSE);
	}
}

void CMainFrame::OnUpdateViewToolbox(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_FileBar.IsWindowVisible());
}



